#!/bin/bash

# ce script prend en argument une image
# et genere une video representant l'effet de
# zoom sur l'image


if [ ! "$#" = "1" ]
then
	echo "Need a image as 1st argument"
	exit -1
fi

SRC=$1

if [ ! -f "$SRC" ]
then
	echo "image $SRC not found, check argument"
	exit -1
fi

W=`identify paris.jpg  | gawk '{print $3}' | gawk -F"x" '{print $1}'`
H=`identify paris.jpg  | gawk '{print $3}' | gawk -F"x" '{print $2}'`

if [ "$H" = "" ]
then
	echo "image $SRC not found, check argument"
	exit -1
fi

if [ "$W" = "" ]
then
	echo "image $SRC not found, check argument"
	exit -1
fi

let L=${W}/4

BUILD=build.$$
rm -rf ${BUILD}
mkdir -p ${BUILD}

for i in `seq 200 280`
do
	let POSX=$(( (${i}-200)*4 ))
	let POSY=$(( ${POSX}*${H}/${W} ))
	let X=800-${POSX}
	let Y=600-${POSY}
	convert -quality 100 $SRC  -crop ${X}x${Y}+${POSX}+${POSY} ${BUILD}/zoom.jpg
	convert -resize ${W}x${H} ${BUILD}/zoom.jpg ${BUILD}/${i}.jpg
	rm -f ${BUILD}/zoom.jpg
done

mkdir -p zoom
find "${BUILD}" -name "*.jpg" | sort -u > ${BUILD}/liste_jpg.txt
mencoder mf://@${BUILD}/liste_jpg.txt -mf fps=25 -o "zoom/`basename $SRC`.zoom1.avi" -ovc lavc -lavcopts vcodec=msmpeg4v2:vbitrate=8500
find "${BUILD}" -name "*.jpg" | sort -r > ${BUILD}/liste_jpg2.txt
mencoder mf://@${BUILD}/liste_jpg2.txt -mf fps=25 -o "zoom/`basename $SRC`.zoom2.avi" -ovc lavc -lavcopts vcodec=msmpeg4v2:vbitrate=8500

LAST=`cat ${BUILD}/liste_jpg.txt | tail -n 1`
for i in `seq 1 5`
do
	echo "$LAST" >> ${BUILD}/list_jpg3.txt
done

mencoder mf://@${BUILD}/list_jpg3.txt -mf fps=25 -o "zoom/`basename $SRC`.zoom3.avi" -ovc lavc -lavcopts vcodec=msmpeg4v2:vbitrate=8500

mencoder -ovc copy -oac copy `basename $SRC`.zoom1.avi  `zoom/basename $SRC`.zoom3.avi `basename $SRC`.zoom2.avi -o `basename $SRC`.zoom.avi
rm -rf ${BUILD}

echo ""
echo "All done, see `basename zoom/$SRC`.zoom1.avi zoom/`basename $SRC`.zoom2.avi zoom/`basename $SRC`.zoom.avi"